#if	defined(ANSI)	/* ANSI-C */
extern char *imagefile(const char *name);
extern int setimagefile(const char *name, const char *file);
extern int naxis(const char *name);
extern int setnaxis(const char *name, const int n);
extern int naxis1(const char *name);
extern int setnaxis1(const char *name, const int nx);
extern int naxis2(const char *name);
extern int setnaxis2(const char *name, const int ny);
extern int simple(const char *name);
extern int setsimple(const char *name, const int c);
extern int bitpix(const char *name);
extern int setbitpix(const char *name, const int bit);
extern int pixtype(const char *name);
extern int setpixtype(const char *name, const int type);
extern int bytepix(const int type);
extern int pixsize(const char *name);
extern int bpixels(const char *name);
extern long imagesize(const char *name);
extern double bscale(const char *name);
extern int setbscale(const char *name, const double scale);
extern double bbzero(const char *name);
extern int setbzero(const char *name, const double zero);
extern char *bunit(const char *name);
extern int setbunit(const char *name, const char *unit);
extern char *object(const char *name);
extern int setobject(const char *name, const char *obj);
extern char *filter(const char *name);
extern int setfilter(const char *name, const char *fil);
extern char *grism(const char *name);
extern int setgrism(const char *name, const char *gri);
extern char *origin(const char *name);
extern int setorigin(const char *name, const char *org);
extern char *instrume(const char *name);
extern int setinstrume(const char *name, const char *instr);
extern char *telescop(const char *name);
extern int settelescop(const char *name, const char *tel);
extern char *observer(const char *name);
extern int setobserver(const char *name, const char *obs);
extern double crval1(const char *name);
extern double crval2(const char *name);
extern int setcrval1(const char *name, const double crval);
extern int setcrval2(const char *name, const double crval);
extern double crpix1(const char *name);
extern double crpix2(const char *name);
extern int setcrpix1(const char *name, const double crpix);
extern int setcrpix2(const char *name, const double crpix);
extern double cdelt1(const char *name);
extern double cdelt2(const char *name);
extern int setcdelt1(const char *name, const double cdelt);
extern int setcdelt2(const char *name, const double cdelt);
extern double crota1(const char *name);
extern double crota2(const char *name);
extern int setcrota1(const char *name, const double crota);
extern int setcrota2(const char *name, const double crota);
extern char *ctype1(const char *name);
extern char *ctype2(const char *name);
extern int setctype1(const char *name, const char *ctype);
extern int setctype2(const char *name, const char *ctype);
extern double datamax(const char *name);
extern int setdatamax(const char *name, const double max);
extern double datamin(const char *name);
extern int setdatamin(const char *name, const double min);
extern double epoch(const char *name);
extern int setepoch(const char *name, const double ep);
extern double blank(const char *name);
extern int setblank(const char *name, const double blank);
extern char *date(const char *name);
extern char *dateobs(const char *name);
extern int setdate(const char *name);
extern int setdateobs(const char *name);
extern double jdstart(const char *name);
extern int setjdstart(const char *name, const double start);
extern double jdstop(const char *name);
extern int setjdstop(const char *name, const double stop);
extern char *history(const char *name);
extern int sethistory(const char *name, const char *upd);
extern char *iname(const char *name);
extern int setiname(const char *name);
extern int hdrcp(const char *old, const char *new);
extern double exptime(const char *name);
extern int setexptime(const char *name, const double et);
extern double darktime(const char *name);
extern int setdarktime(const char *name, const double dt);
extern double saturate(const char *name);
extern double atodgain(const char *name);
#else	/* old style */
extern char *imagefile();
extern int setimagefile();
extern int naxis();
extern int setnaxis();
extern int naxis1();
extern int setnaxis1();
extern int naxis2();
extern int setnaxis2();
extern int simple();
extern int setsimple();
extern int bitpix();
extern int setbitpix();
extern int pixtype();
extern int setpixtype();
extern int bytepix();
extern int pixsize();
extern int bpixels();
extern long imagesize();
extern double bscale();
extern int setbscale();
extern double bbzero();
extern int setbzero();
extern char *bunit();
extern int setbunit();
extern char *object();
extern int setobject();
extern char *origin();
extern int setorigin();
extern char *instrume();
extern int setinstrume();
extern char *telescop();
extern int settelescop();
extern char *observer();
extern int setobserver();
extern double crval1();
extern double crval2();
extern int setcrval1();
extern int setcrval2();
extern double crpix1();
extern double crpix2();
extern int setcrpix1();
extern int setcrpix2();
extern double cdelt1();
extern double cdelt2();
extern int setcdelt1();
extern int setcdelt2();
extern double crota1();
extern double crota2();
extern int setcrota1();
extern int setcrota2();
extern char *ctype1();
extern char *ctype2();
extern int setctype1();
extern int setctype2();
extern double datamax();
extern int setdatamax();
extern double datamin();
extern int setdatamin();
extern double epoch();
extern int setepoch();
extern double blank();
extern int setblank();
extern char *date();
extern char *dateobs();
extern int setdate();
extern int setdateobs();
extern double jdstart();
extern int setjdstart();
extern double jdstop();
extern int setjdstop();
extern char *history();
extern int sethistory();
extern char *iname();
extern int setiname();
extern int hdrcp();
extern double exptime();
extern int setexptime();
extern double darktime();
extern int setdarktime();
extern double saturate();
extern double atodgain();
#endif
