#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD and SYSV */
#include <stdio.h>	/* declarations for stream I/O functions */
#if	defined(BSD)	/* BSD-UNIX */
#include <strings.h>	/* string header */
#else	/* not BSD-UNIX */
#include <string.h>	/* string header */
#endif
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>	/* errno declared */
#else	/* not ANSI-C */
extern char *getenv();
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*----------------------------------------------------------------------*/
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "args.h"	/* function declaration for args.c */
/*----------------------------------------------------------------------*/
#define	LINSIZE	80
/*----------------------------------------------------------------------*/
#if	defined(ANSI)
static char **GetArg(char *fname, int *argc)
#else	/* old style */
static char **GetArg(fname, argc)
char *fname;
int *argc;
#endif
{
	char *p, *q, line[LINSIZE], **tmp, **argv = NULL;
	int n, m = sizeof(char *);
	FILE *stream;

	if ((stream = fopen(fname, "r")) == NULL) {
		*argc = 0;
		return NULL;	/* can't open agrument file */
	}

	for (n = 0; fgets(line, LINSIZE, stream) != NULL; n++) {
		if ((tmp = (char **)realloc(argv, m)) == NULL)
			break;	/* can't reallocate string pointer table */
		argv = tmp;	/* string pointer table reallocated */
		if ((argv[n] = (char *)calloc(strlen(line)+1, sizeof(char))) == NULL)
			break;	/* can't allocate argument string */
		p = argv[n];
		q = line;
		while (*q != '\n' && *q != '\0')	/* copy next argument */
			*p++ = *q++;
		*p = '\0';	/* end of string */
		m += sizeof(char *);	/* increment pointer table */
	}

	fclose(stream);
	*argc = n;	/* number of arguments */
	return argv;
}
/*----------------------------------------------------------------------*/
#if	defined(ANSI)
void PutArg(char *fname, int argc, char **argv)
#else	/* old style */
void PutArg(fname, argc, argv)
char *fname;
int argc;
char **argv;
#endif
{
	int i;
	FILE *stream;

	if ((stream = fopen(fname, "w")) != NULL) {
		for (i = 0; i < argc; i++)
			if (fputs(argv[i], stream) == EOF || fputc('\n', stream) == EOF)
				break;
		fclose(stream);
	}
}
/*----------------------------------------------------------------------*/
#if	defined(ANSI)
void FileName(char *pname)
#else	/* old style */
void FileName(pname)
char *pname;
#endif
{
	char *p, *q = pname;

	for (p = pname; *p != '.' && *p != '\0'; p++) ;
	*p = '\0';
	for (; p > pname; p--)
		if (*p == '\\' || *p == '/') {
			p++;
			break;
		}
	while ((*q++ = *p++) != '\0') ;
}
/*----------------------------------------------------------------------*/
#if	defined(ANSI)
char **args(int argc, char **argv, int *nargs)
#else	/* old style */
char **args(argc, argv, nargs)
int argc;
char **argv;
int *nargs;
#endif
{
	int old_argc, new_argc, i, n = 6;
	char **old_argv, **new_argv, *file, *path;

	if ((path = getenv("ARGS")) != NULL)
		n += strlen(path);
	FileName(argv[0]);
	n += strlen(argv[0]);
	if ((file = (char *)calloc(n, sizeof(char))) == NULL) {
		*nargs = argc;
		return argv;
	}
	*file = '\0';
	if (path != NULL) {
		strcat(file, path);
		strcat(file, "/");
	}
	strcat(file, argv[0]);
	strcat(file, ".arg");
	old_argv = GetArg(file, &old_argc);

	for (n = 1; n < argc; n++)
		if (*argv[n] == '!')
			break;
		else if (*argv[n] == ':' && n >= old_argc)
				break;

	new_argc = n;

	if (n < argc && n < old_argc && *argv[n] == '!')
		new_argc = old_argc;

	if ((new_argv = (char **)calloc(new_argc, sizeof(char *))) == NULL) {
		*nargs = n;
		return argv;
	}

	new_argv[0] = argv[0];

	for (i = 1; i < n; i++)
		if (*argv[i] == ':')
			new_argv[i] = old_argv[i];
		else
			new_argv[i] = argv[i];

	for (i = n; i < new_argc; i++)
		new_argv[i] = old_argv[i];

	PutArg(file, new_argc, new_argv);

	*nargs = new_argc;
	return new_argv;
}
/*----------------------------------------------------------------------*/
