#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>
/*----------------------------------------------------------------------*/
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "bufsiz.h"	/* function declarations for bufsiz.c */
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
int msb(unsigned x)
#else	/* old style */
int msb(x)	/* position of most significant bit */
unsigned x;
#endif
{
	int n;
	for (n = -1; x ; n++)
		x >>= 1;
	return(n);	/* returns -1 if x = 0 */
}
/*----------------------------------------------------------------------*/
static int BufLen = -1;	/* Buffer size = 2**BufLen */
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void setbufsiz(unsigned size)
#else	/* old style */
void setbufsiz(size)	/* set stream buffer size */
unsigned size;
#endif
{
		if (BUF_SIZ != 0)	/* change buffer block size if BUF_SIZ != 0 */
			BufLen = msb(size);	/* Buffer size = 2**BufLen */
		else
			BufLen = msb(BUFSIZ);
}
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
unsigned buffsize(void)
#else	/* old style */
unsigned buffsize()	/* block size */
#endif
{
	if (BufLen < 0)	/* BufLen has not been initialized */
		setbufsiz(BUF_SIZ);	/* initialize BufLen */
	return (1 << BufLen);	/* return the buffer block size in bytes */
}
/*----------------------------------------------------------------------*/
