/* Copyright 1993 by P. J. LaBrocca */
/*--------------------------------------------------------------------*/
#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>	/* ANSI declarations */
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "dyn2darr.h"	/* function declarations for dyn2darr.c */
/*--------------------------------------------------------------------*/
#include "vmalloc.h"	/* function declarations for vmalloc.c */
#include "chkheap.h"	/* redefine malloc functions */
/*--------------------------------------------------------------------*/
/*
	Allocates a block of memory that can be accessed as
	a two-dimensional array using subscript operators.
	Use macro defined defined in dyn2darr.h, Dyn2dArray,
	instead of function.
*/
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void **dyn2darray(unsigned row, unsigned col, unsigned el_size)
#else	/* old style */
void **dyn2darray(row, col, el_size)
unsigned row, col, el_size;
#endif
{
	unsigned c;
	char *p = (char *)0;
	void **arr = (void **) calloc(
		row * sizeof(void *) + /* for pointers */
		row * col * el_size +  /* for elements */
		2 * sizeof(unsigned),  /* for dimensions */
		sizeof(char));

	if (arr == (void **)0)
		return arr;

	/* store row and col */
	p = (char *) arr + row * sizeof(void *);
	*(unsigned *) p = row;
	p += sizeof(unsigned);	/* p is a pointer to char */
	*(unsigned *) p = col;
	p += sizeof(unsigned);

	/* link rows to pointers */
	for (c = 0; c < row; ++c)
		arr[c] = p + (c * col * el_size);

	return arr;
}
