#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>	/* errno declared */
#else	/* not ANSI-C */
extern char *getenv();
#endif
/*----------------------------------------------------------------------*/
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "imhdr.h"	/* function declarations for imhdr.c */
#include "imkw.h"	/* function declarations for imkw.c */
#include "imio.h"	/* function declarations for imio.c */
#include "ftnif.h"	/* function declarations for ftnif.c */
/*----------------------------------------------------------------------*/
/*
	These functions make it possible to access images under IMSYS
	from a Fortran program. Various compilers use to prefix and/or
	append an underscore to global variables and function names.
	Some linkers cannot distinguish upper and lower case letters,
	and some are only sensitive to the first few (6?) letters in
	external names. There are also several different ways to
	transfer the formal parameters to a function or subroutine,
	and it looks as if all possible techniques have been used.
*/
/*
	Select header directory as given by the environment string: HDRPATH
	Select image directory as given by the invironment string: IMGPATH
	Allocate a list of all image headers, image.HDR, in the header directory
	It should be called before any image references
		Return:
			 1:	Header list successfully allocated
			 0:	Not space for all header entries
			-1:	Cannot read header directory
*/
#if	defined(WATCOM)
int IBEGIN(void) { setipath(0); return prolog(0); }
#endif
#if	defined(DEC)
int ibegin__() { setipath(0); return prolog(0); }
#endif
#if	defined(F2C)
int ibegin___(void) { setipath(0); return prolog(0); }
#endif
#if	defined(HP300) || defined(HP800)
int ibegin_() { setipath(0); return prolog(0); }
#endif
/*
	Update header files, that have been modified,
	but retain the image list.
		Return:
			1:	Header files successfully updated
			0:	Some header files have not been updated
*/
#if	defined(WATCOM)
int IUPD(void) { return update(); }
#endif
#if	defined(DEC)
int iupd__() { return update(); }
#endif
#if	defined(F2C)
int iupd___(void) { return update(); }
#endif
#if	defined(HP300) || defined(HP800)
int iupd_() { return update(); }
#endif
/*
	Update header files, that have been modified,
	and deallocate the image list.
	It should be called before exit from program.
		Return:
			1:	Header files successfully updated
			0:	Some header files have not been updated
*/
#if	defined(WATCOM)
int IEND(void) { return epilog(); }
#endif
#if	defined(DEC)
int iend__() { return epilog(); }
#endif
#if	defined(F2C)
int iend___(void) { return epilog(); }
#endif
#if	defined(HP300) || defined(HP800)
int iend_() { return epilog(); }
#endif
/*
	Return:	Number of dimensions (normally 2). Failure = 0
	Input:	String containing image name terminated by char(0)
	The image name must not contain a '.'
*/
#if	defined(WATCOM)
int MAXIS(DESCRIPTOR *name) { return naxis(truncname(name->addr)); }
#endif
#if	defined(DEC)
int maxis__(name, len)
char *name; int len; { return naxis(truncname(name)); }
#endif
#if	defined(F2C)
int maxis___(char *name, int len) { return naxis(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
int maxis_(name, len)
char *name; int len; { return naxis(truncname(name)); }
#endif
/*
	Set NAXIS value
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			n:		NAXIS value
*/
#if	defined(WATCOM)
int IAXIS(DESCRIPTOR *name, int *n)
{ return setnaxis(truncname(name->addr), *n); }
#endif
#if	defined(DEC)
int iaxis__(name, n, len)
char *name; int *n; int len; { return setnaxis(truncname(name), *n); }
#endif
#if	defined(F2C)
int iaxis___(char *name, int *n, int len)
{ return setnaxis(truncname(name), *n); }
#endif
#if	defined(HP800)
int iaxis_(name, len, n)
char *name; int len; int *n; { return setnaxis(truncname(name), *n); }
#endif
#if	defined(HP300)
int iaxis_(name, n, len)
char *name; int *n; int len; { return setnaxis(truncname(name), *n); }
#endif
/*
	Return:	Number of pixels along axis 1. Failure = 0
	Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
int MAXIS1(DESCRIPTOR *name) { return naxis1(truncname(name->addr)); }
#endif
#if	defined(DEC)
int maxis1__(name, len)
char *name; int len; { return naxis1(truncname(name)); }
#endif
#if	defined(F2C)
int maxis1___(char *name, int len) { return naxis1(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
int maxis1_(name, len)
char *name; int len; { return naxis1(truncname(name)); }
#endif
/*
	Set NAXIS1 value
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			nx:	NAXIS1 value
*/
#if	defined(WATCOM)
int IAXIS1(DESCRIPTOR *name, int *nx)
{ return setnaxis1(truncname(name->addr), *nx); }
#endif
#if	defined(DEC)
int iaxis1__(name, nx, len)
char *name; int *nx; int len; { return setnaxis1(truncname(name), *nx); }
#endif
#if	defined(F2C)
int iaxis1___(char *name, int *nx, int len)
{ return setnaxis1(truncname(name), *nx); }
#endif
#if	defined(HP800)
int iaxis1_(name, len, nx)
char *name; int len; int *nx; { return setnaxis1(truncname(name), *nx); }
#endif
#if	defined(HP300)
int iaxis1_(name, nx, len)
char *name; int *nx; int len; { return setnaxis1(truncname(name), *nx); }
#endif
/*
	Return:	Number of pixels along axis 2. Failure = 0
	Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
int MAXIS2(DESCRIPTOR *name) { return naxis2(truncname(name->addr)); }
#endif
#if	defined(DEC)
int maxis2__(name, len)
char *name; int len; { return naxis2(truncname(name)); }
#endif
#if	defined(F2C)
int maxis2___(char *name, int len) { return naxis2(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
int maxis2_(name, len)
char *name; int len; { return naxis2(truncname(name)); }
#endif
/*
	Set NAXIS2 value
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			ny:	NAXIS2 value
*/
#if	defined(WATCOM)
int IAXIS2(DESCRIPTOR *name, int *ny)
{ return setnaxis2(truncname(name->addr), *ny); }
#endif
#if	defined(DEC)
int iaxis2__(name, ny, len)
char *name; int *ny; int len; { return setnaxis2(truncname(name), *ny); }
#endif
#if	defined(F2C)
int iaxis2___(char *name, int *ny, int len)
{ return setnaxis2(truncname(name), *ny); }
#endif
#if	defined(HP800)
int iaxis2_(name, len, ny)
char *name; int len; int *ny; { return setnaxis2(truncname(name), *ny); }
#endif
#if	defined(HP300)
int iaxis2_(name, ny, len)
char *name; int *ny; int len; { return setnaxis2(truncname(name), *ny); }
#endif
/*
	Return:
		1:	SIMPLE = T	(A simple FITS image)
		0:	SIMPLE = F	(Not a simple FITS image)
	Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
int MSIMPL(DESCRIPTOR *name) { return simple(truncname(name->addr)); }
#endif
#if	defined(DEC)
int msimpl__(name, len)
char *name; int len; { return simple(truncname(name)); }
#endif
#if	defined(F2C)
int msimpl___(char *name, int len) { return simple(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
int msimpl_(name, len)
char *name; int len; { return simple(truncname(name)); }
#endif
/*
	Set SIMPLE value	(T or F)
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			c:		1 -> T, 0 -> F
*/
#if	defined(WATCOM)
int ISIMPL(DESCRIPTOR *name, int *c)
{ return setsimple(truncname(name->addr), *c); }
#endif
#if	defined(DEC)
int isimpl__(name, c, len)
char *name; int *c; int len; { return setsimple(truncname(name), *c); }
#endif
#if	defined(F2C)
int isimpl___(char *name, int *c, int len)
{ return setsimple(truncname(name), *c); }
#endif
#if	defined(HP800)
int isimpl_(name, len, c)
char *name; int len; int *c; { return setsimple(truncname(name), *c); }
#endif
#if	defined(HP300)
int isimpl_(name, c, len)
char *name; int *c; int len; { return setsimple(truncname(name), *c); }
#endif
/*
	Return:	Number of bits per pixel. Failure = 0
	Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
int MBITPX(DESCRIPTOR *name) { return bitpix(truncname(name->addr)); }
#endif
#if	defined(DEC)
int mbitpx__(name, len)
char *name; int len; { return bitpix(truncname(name)); }
#endif
#if	defined(F2C)
int mbitpx___(char *name, int len) { return bitpix(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
int mbitpx_(name, len)
char *name; int len; { return bitpix(truncname(name)); }
#endif
/*
	Set BITPIX value	(8, 16, 32, or 64)
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			bit:	BITPIX value
*/
#if	defined(WATCOM)
int IBITPX(DESCRIPTOR *name, int *bit)
{ return setbitpix(truncname(name->addr), *bit); }
#endif
#if	defined(DEC)
int ibitpx__(name, bit, len)
char *name; int *bit; int len; { return setbitpix(truncname(name), *bit); }
#endif
#if	defined(F2C)
int ibitpx___(char *name, int *bit, int len)
{ return setbitpix(truncname(name), *bit); }
#endif
#if	defined(HP800)
int ibitpx_(name, len, bit)
char *name; int len; int *bit; {return setbitpix(truncname(name), *bit); }
#endif
#if	defined(HP300)
int ibitpx_(name, bit, len)
char *name; int *bit; int len; { return setbitpix(truncname(name), *bit); }
#endif
/*
	Return:
		0:	Failure
		1:	Unsigned character
		2:	16-bit signed integer
		3:	32-bit floating point real
		4:	32-bit signed integer
		5:	64-bit complex (2 32-bit reals)
	Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
int MPXTYP(DESCRIPTOR *name) { return pixtype(truncname(name->addr)); }
#endif
#if	defined(DEC)
int mpxtyp__(name, len)
char *name; int len; { return pixtype(truncname(name)); }
#endif
#if	defined(F2C)
int mpxtyp___(char *name, int len) { return pixtype(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
int mpxtyp_(name, len)
char *name; int len; { return pixtype(truncname(name)); }
#endif
/*
	Set PIXTYPE value	(1, 2, 3, 4, or 5)
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			type:	PIXTYPE value
*/
#if	defined(WATCOM)
int IPXTYP(DESCRIPTOR *name, int *type)
{ return setpixtype(truncname(name->addr), *type); }
#endif
#if	defined(DEC)
int ipxtyp__(name, type, len)
char *name; int *type; int len;
{ return setpixtype(truncname(name), *type); }
#endif
#if	defined(F2C)
int ipxtyp___(char *name, int *type, int len)
{ return setpixtype(truncname(name), *type); }
#endif
#if	defined(HP800)
int ipxtyp_(name, len, type)
char *name; int len; int *type;
{ return setpixtype(truncname(name), *type); }
#endif
#if	defined(HP300)
int ipxtyp_(name, type, len)
char *name; int *type; int len;
{ return setpixtype(truncname(name), *type); }
#endif
/*
	Return:	Maximum data value as 32-bit real. Failure = 0.0
	Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
float DATMAX(DESCRIPTOR *name)
{ return (float) datamax(truncname(name->addr)); }
#endif
#if	defined(DEC)
float datmax__(name, len)
char *name; int len; { return (float) datamax(truncname(name)); }
#endif
#if	defined(F2C)
float datmax___(char *name, int len)
{ return (float) datamax(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
float datmax_(name, len)
char *name; int len; { return (float) datamax(truncname(name)); }
#endif
/*
	Set DATAMAX value
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			max:	DATAMAX value (32-bit real)
*/
#if	defined(WATCOM)
int IDTMAX(DESCRIPTOR *name, float *max)
{ return setdatamax(truncname(name->addr), (double) *max); }
#endif
#if	defined(DEC)
int idtmax__(name, max, len)
char *name; float *max; int len;
{ return setdatamax(truncname(name), (double) *max); }
#endif
#if	defined(F2C)
int idtmax___(char *name, float *max, int len)
{ return setdatamax(truncname(name), (double) *max); }
#endif
#if	defined(HP800)
int idtmax_(name, len, max)
char *name; int len; float *max;
{ return setdatamax(truncname(name), (double) *max); }
#endif
#if	defined(HP300)
int idtmax_(name, max, len)
char *name; float *max; int len;
{ return setdatamax(truncname(name), (double) *max); }
#endif
/*
	Return:	Minimum data value as 32-bit real. Failure = 0.0
	Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
float DATMIN(DESCRIPTOR *name)
{ return (float) datamin(truncname(name->addr)); }
#endif
#if	defined(DEC)
float datmin__(name, len)
char *name; int len; { return (float) datamin(truncname(name)); }
#endif
#if	defined(F2C)
float datmin___(char *name, int len)
{ return (float) datamin(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
float datmin_(name, len)
char *name; int len; { return (float) datamin(truncname(name)); }
#endif
/*
	Set DATAMIN value
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			min:	DATAMIN value (32-bit real)
*/
#if	defined(WATCOM)
int IDTMIN(DESCRIPTOR *name, float *min)
{ return setdatamin(truncname(name->addr), (double) *min); }
#endif
#if	defined(DEC)
int idtmin__(name, min, len)
char *name; float *min; int len;
{ return setdatamin(truncname(name), (double) *min); }
#endif
#if	defined(F2C)
int idtmin___(char *name, float *min, int len)
{ return setdatamin(truncname(name), (double) *min); }
#endif
#if	defined(HP800)
int idtmin_(name, len, min)
char *name; int len; float *min;
{ return setdatamin(truncname(name), (double) *min); }
#endif
#if	defined(HP300)
int idtmin_(name, min, len)
char *name; float *min; int len;
{ return setdatamin(truncname(name), (double) *min); }
#endif
/*
	Return:	32-bit real value indicating bad pixels. Failure = 0.0
	Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
float FBLANK(DESCRIPTOR *name)
{ return (float) blank(truncname(name->addr)); }
#endif
#if	defined(DEC)
float fblank__(name, len)
char *name; int len; { return (float) blank(truncname(name)); }
#endif
#if	defined(F2C)
float fblank___(char *name, int len)
{ return (float) blank(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
float fblank_(name, len)
char *name; int len; { return (float) blank(truncname(name)); }
#endif
/*
	Set BLANK value
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String containing image name terminated by char(0)
			blank:	BLANK value (32-bit real)
*/
#if	defined(WATCOM)
int IBLANK(DESCRIPTOR *name, float *blank)
{ return setblank(truncname(name->addr), (double) *blank); }
#endif
#if	defined(DEC)
int iblank__(name, blank, len)
char *name; float *blank; int len;
{ return setblank(truncname(name), (double) *blank); }
#endif
#if	defined(F2C)
int iblank___(char *name, float *blank, int len)
{ return setblank(truncname(name), (double) *blank); }
#endif
#if	defined(HP800)
int iblank_(name, len, blank)
char *name; int len; float *blank;
{ return setblank(truncname(name), (double) *blank); }
#endif
#if	defined(HP300)
int iblank_(name, blank, len)
char *name; float *blank; int len;
{ return setblank(truncname(name), (double) *blank); }
#endif
/*
	Get object name
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	String with image name terminated by char(0)
			n:	Number of characters in obj
		Output:
			obj:	String with object name terminated by spaces
*/
#if	defined(WATCOM)
int IGOBJ(DESCRIPTOR *name, int *n, DESCRIPTOR *obj)
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj->addr[i] = ' ';
	if ((s = object(truncname(name->addr))) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj->addr[i] = s[i];
		return 1;
	}
}
#endif
#if	defined(DEC)
int igobj__(name, n, obj, len1, len2)
char *name; int *n; char *obj; int len1, len2;
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj[i] = ' ';
	if ((s = object(truncname(name))) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj[i] = s[i];
		return 1;
	}
}
#endif
#if	defined(F2C)
int igobj___(char *name, int *n, char *obj, int len1, int len2)
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj[i] = ' ';
	if ((s = object(truncname(name))) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj[i] = s[i];
		return 1;
	}
}
#endif
#if	defined(HP800)
int igobj_(name, len1, n, obj, len2)
char *name; int len1; int *n; char *obj; int len2;
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj[i] = ' ';
	if ((s = object(truncname(name))) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj[i] = s[i];
		return 1;
	}
}
#endif
#if	defined(HP300)
int igobj_(name, n, obj, len1, len2)
char *name; int *n; char *obj; int len1, len2;
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj[i] = ' ';
	if ((s = object(truncname(name))) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj[i] = s[i];
		return 1;
	}
}
#endif
/*
	Delete existing image
		Return:
			 0:	Successful
			-1:	Unsuccessful
		Input:	String containing image name terminated by char(0)
*/
#if	defined(WATCOM)
int IMDEL(DESCRIPTOR *name) { return idel(truncname(name->addr)); }
#endif
#if	defined(DEC)
int imdel__(name, len)
char *name; int len; { return idel(truncname(name)); }
#endif
#if	defined(F2C)
int imdel___(char *name, int len) { return idel(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
int imdel_(name, len)
char *name; int len; { return idel(truncname(name)); }
#endif
/*
	Open existing image for reading or updating (reading and writing)
		Return:	Image number. Failure = -1
		Input:
			name:	String containing image name terminated by char(0)
			rw:	0 = read only, 2 = read and write
		Output:
			type:	Image type (1, 2, 3, 4, 5)
			npix:	Number of pixels along x-axis
			nlin:	Number of lines (pixels along y-axis)
*/
#if	defined(WATCOM)
int IMOPEN(DESCRIPTOR *name, int *rw, int *type, int *npix, int *nlin)
{ return iopen(truncname(name->addr), *rw, type, npix, nlin); }
#endif
#if	defined(DEC)
int imopen__(name, rw, type, npix, nlin, len)
char *name; int *rw, *type, *npix, *nlin; int len;
{ return iopen(truncname(name), *rw, type, npix, nlin); }
#endif
#if	defined(F2C)
int imopen___(char *name, int *rw, int *type, int *npix, int *nlin, int len)
{ return iopen(truncname(name), *rw, type, npix, nlin); }
#endif
#if	defined(HP800)
int imopen_(name, len, rw, type, npix, nlin)
char *name; int len; int *rw, *type, *npix, *nlin;
{ return iopen(truncname(name), *rw, type, npix, nlin); }
#endif
#if	defined(HP300)
int imopen_(name, rw, type, npix, nlin, len)
char *name; int *rw, *type, *npix, *nlin; int len;
{ return iopen(truncname(name), *rw, type, npix, nlin); }
#endif
/*
	Change mode for reading or updating an open image file
		Return:
			1: Successful
			0: Unsuccessful
		Input:
			id:	Image number (as returned by iopen/icreat/icopy)
			rw:	0 = read only, 2 = update (read and write) 
*/
#if	defined(WATCOM)
int ICHIOM(int *id, int *rw) { return chiomod(*id, *rw); }
#endif
#if	defined(DEC)
int ichiom__(id, rw)
int *id, *rw; { return chiomod(*id, *rw); }
#endif
#if	defined(F2C)
int ichiom___(int *id, int *rw) { return chiomod(*id, *rw); }
#endif
#if	defined(HP300) || defined(HP800)
int ichiom_(id, rw)
int *id, *rw; { return chiomod(*id, *rw); }
#endif
/*
	Create a new image for writing or reading and writing
		Return:	Image number. Failure = -1
		Input:
			name:	String containing image name terminated by char(0)
			rw:	1 = write only, 2 = read and write
			type:	Image type (1, 2, 3, 4, 5)
			npix:	Number of pixels along x-axis
			nlin:	Number of lines (pixels along y-axis)
*/
#if	defined(WATCOM)
int MCREAT(DESCRIPTOR *name, int *rw, int *type, int *npix, int *nlin)
{ return icreat(truncname(name->addr), *rw, *type, *npix, *nlin); }
#endif
#if	defined(DEC)
int mcreat__(name, rw, type, npix, nlin, len)
char *name; int *rw, *type, *npix, *nlin; int len;
{ return icreat(truncname(name), *rw, *type, *npix, *nlin); }
#endif
#if	defined(F2C)
int mcreat___(char *name, int *rw, int *type, int *npix, int *nlin, int len)
{ return icreat(truncname(name), *rw, *type, *npix, *nlin); }
#endif
#if	defined(HP800)
int mcreat_(name, len, rw, type, npix, nlin)
char *name; int len; int *rw, *type, *npix, *nlin;
{ return icreat(truncname(name), *rw, *type, *npix, *nlin); }
#endif
#if	defined(HP300)
int mcreat_(name, rw, type, npix, nlin, len)
char *name; int *rw, *type, *npix, *nlin; int len;
{ return icreat(truncname(name), *rw, *type, *npix, *nlin); }
#endif
/*
	Copy existing image header to new header
		Return:
         0: Successful
        -1: Unsuccessful
		Input:
			oname:	String containing old image name terminated by char(0)
			nname:	String containing new image name terminated by char(0)
*/
#if	defined(WATCOM)
int IHDRCP(DESCRIPTOR *oname, DESCRIPTOR *nname)
{ return hdrcp(truncname(oname->addr), truncname(nname->addr)); }
#endif
#if	defined(DEC)
int ihdrcp__(oname, nname, len1, len2)
char *oname; char *nname; int len1, len2;
{ return hdrcp(truncname(oname), truncname(nname)); }
#endif
#if	defined(F2C)
int ihdrcp___(char *oname, char *nname, int len1, int len2)
{ return hdrcp(truncname(oname), truncname(nname)); }
#endif
#if	defined(HP800)
int ihdrcp_(oname, len1, nname, len2)
char *oname; int len1; char *nname; int len2;
{ return hdrcp(truncname(oname), truncname(nname)); }
#endif
#if	defined(HP300)
int ihdrcp_(oname, nname, len1, len2)
char *oname; char *nname; int len1, len2;
{ return hdrcp(truncname(oname), truncname(nname)); }
#endif
/*
	Copy existing image to new image using the existing header
		Return:	Image number. Failure = -1
		Input:
			oname:	String containing old image name terminated by char(0)
			nname:	String containing new image name terminated by char(0)
			rw:	 0 = read only, 1 = write only, 2 = read and write
			cpf:	-1 = create and extend, 0 = copy only, 1 = copy and open
*/
#if	defined(WATCOM)
int IMCOPY(DESCRIPTOR *oname, DESCRIPTOR *nname, int *rw, int *cpf)
{ return icopy(truncname(oname->addr), truncname(nname->addr), *rw, *cpf); }
#endif
#if	defined(DEC)
int imcopy__(oname, nname, rw, cpf, len1, len2)
char *oname; char *nname; int *rw, *cpf; int len1, len2;
{ return icopy(truncname(oname), truncname(nname), *rw, *cpf); }
#endif
#if	defined(F2C)
int imcopy___(char *oname, char *nname, int *rw, int *cpf, int len1, int len2)
{ return icopy(truncname(oname), truncname(nname), *rw, *cpf); }
#endif
#if	defined(HP800)
int imcopy_(oname, len1, nname, len2, rw, cpf)
char *oname; int len1; char *nname; int len2; int *rw, *cpf;
{ return icopy(truncname(oname), truncname(nname), *rw, *cpf); }
#endif
#if	defined(HP300)
int imcopy_(oname, nname, rw, cpf, len1, len2)
char *oname; char *nname; int *rw, *cpf; int len1, len2;
{ return icopy(truncname(oname), truncname(nname), *rw, *cpf); }
#endif
/*
	Define a data window which is smaller than the full image
	Default is the full image
		Return:
			1:	Successful, data window is inside image
			0:	Unsuccessful, window extends outside image
		Input:
			id:	Image number (as returned by iopen/icreat/icopy)
			stx:	Start x
			sty:	Start y
			extx:	Extend x
			exty:	Extend y
*/
#if	defined(WATCOM)
int IMWIN(int *id, int *stx, int *sty, int *extx, int *exty)
{ return window(*id, *stx, *sty, *extx, *exty); }
#endif
#if	defined(DEC)
int imwin__(id, stx, sty, extx, exty)
int *id, *stx, *sty, *extx, *exty;
{ return window(*id, *stx, *sty, *extx, *exty); }
#endif
#if	defined(F2C)
int imwin___(int *id, int *stx, int *sty, int *extx, int *exty)
{ return window(*id, *stx, *sty, *extx, *exty); }
#endif
#if	defined(HP300) || defined(HP800)
int imwin_(id, stx, sty, extx, exty)
int *id, *stx, *sty, *extx, *exty;
{ return window(*id, *stx, *sty, *extx, *exty); }
#endif
/*
	Read one line from data window as defined by iwin
		Return:	Number of pixels read
		Input:
			id:	Image number (as returned by iopen/icreat/icopy)
			y:		Line number, starting from 0 at top of window
		Output:
			line:	Line buffer returning line y from data window
*/
#if	defined(WATCOM)
int IMGETL(int *id, int *y, char *line) { return getline(*id, *y, line); }
#endif
#if	defined(DEC)
int imgetl__(id, y, line)
int *id, *y; char *line; { return getline(*id, *y, line); }
#endif
#if	defined(F2C)
int imgetl___(int *id, int *y, char *line) { return getline(*id, *y, line); }
#endif
#if	defined(HP300) || defined(HP800)
int imgetl_(id, y, line)
int *id, *y; char *line; { return getline(*id, *y, line); }
#endif
/*
	Write one line to data window as defined by iwin
		Return:	Number of pixels written
		Input:
			id:	Image number (as returned by iopen/icreat/icopy)
			y:		Line number, starting from 0 at top of window
			line:	Line buffer containing the line to be written
*/
#if	defined(WATCOM)
int IMPUTL(int *id, int *y, char *line) { return putline(*id, *y, line); }
#endif
#if	defined(DEC)
int imputl__(id, y, line)
int *id, *y; char *line; { return putline(*id, *y, line); }
#endif
#if	defined(F2C)
int imputl___(int *id, int *y, char *line) { return putline(*id, *y, line); }
#endif
#if	defined(HP300) || defined(HP800)
int imputl_(id, y, line)
int *id, *y; char *line; { return putline(*id, *y, line); }
#endif
/*
	Read one "natural" block of pixels from full image
		Return:	Number of pixels read
		Input:
			id:	Image number (as returned by iopen/icreat/icopy)
			blk:	Block number, starting from 0 at beginning of image
		Output:
			buf:	Buffer returning a "natural" block of pixels
*/
#if	defined(WATCOM)
int IMBRD(int *id, int *blk, char *buf) { return bread(*id, *blk, buf); }
#endif
#if	defined(DEC)
int imbrd__(id, blk, buf)
int *id, *blk; char *buf; { return bread(*id, *blk, buf); }
#endif
#if	defined(F2C)
int imbrd___(int *id, int *blk, char *buf) { return bread(*id, *blk, buf); }
#endif
#if	defined(HP300) || defined(HP800)
int imbrd_(id, blk, buf)
int *id, *blk; char *buf; { return bread(*id, *blk, buf); }
#endif
/*
	Write one "natural" block of pixels to full image
		Return:	Number of pixels written
		Input:
			id:	Image number (as returned by iopen/icreat/icopy)
			blk:	Block number, starting from 0 at beginning of image
			buf:	Buffer containing a "natural" block to be written
*/
#if	defined(WATCOM)
int IMBWR(int *id, int *blk, char *buf) { return bwrite(*id, *blk, buf); }
#endif
#if	defined(DEC)
int imbwr__(id, blk, buf)
int *id, *blk; char *buf; { return bwrite(*id, *blk, buf); }
#endif
#if	defined(F2C)
int imbwr___(int *id, int *blk, char *buf) { return bwrite(*id, *blk, buf); }
#endif
#if	defined(HP300) || defined(HP800)
int imbwr_(id, blk, buf)
int *id, *blk; char *buf; { return bwrite(*id, *blk, buf); }
#endif
/*
	Flush image
		Input:
			id:	Image number (as returned by iopen/icreat/icopy)
*/
#if	defined(WATCOM)
void MFLUSH(int *id) { iflush(*id); }
#endif
#if	defined(DEC)
void mflush__(id)
int *id; { iflush(*id); }
#endif
#if	defined(F2C)
void mflush___(int *id) { iflush(*id); }
#endif
#if	defined(HP300) || defined(HP800)
void mflush_(id)
int *id; { iflush(*id); }
#endif
/*
	Close image
		Input:
			id:	Image number (as returned by iopen/icreat/icopy)
*/
#if	defined(WATCOM)
void MCLOSE(int *id) { iclose(*id); }
#endif
#if	defined(DEC)
void mclose__(id)
int *id; { iclose(*id); }
#endif
#if	defined(F2C)
void mclose___(int *id) { iclose(*id); }
#endif
#if	defined(HP300) || defined(HP800)
void mclose_(id)
int *id; { iclose(*id); }
#endif
/*
		Return:	Number of pixels in one "natural" image block
		Input:	None
*/
#if	defined(WATCOM)
int IMBPIX(DESCRIPTOR *name) { return bpixels(truncname(name->addr)); }
#endif
#if	defined(DEC)
int imbpix__(name, len)
char *name; int len; { return bpixels(truncname(name)); }
#endif
#if	defined(F2C)
int imbpix___(char *name, int len) { return bpixels(truncname(name)); }
#endif
#if	defined(HP300) || defined(HP800)
int imbpix_(name, len)
char *name; int len; { return bpixels(truncname(name)); }
#endif
/*====================================================================*/
/*
	Get environment object (string)
		Return:
			1:	Successful
			0:	Unsuccessful
		Input:
			name:	Environment name terminated by char(0)
			n:    Number of characters in obj
		Output:
			obj:	String with environment object terminated by spaces
*/
#if	defined(WATCOM)
int IGENV(DESCRIPTOR *name, int *n, DESCRIPTOR *obj)
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj->addr[i] = ' ';
	if ((s = getenv(name->addr)) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj->addr[i] = s[i];
		return 1;
	}
}
#endif
#if	defined(DEC)
int igenv__(name, n, obj, len1, len2)
char *name; int *n; char *obj; int len1, len2;
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj[i] = ' ';
	if ((s = getenv(name)) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj[i] = s[i];
		return 1;
	}
}
#endif
#if	defined(F2C)
int igenv___(char *name, int *n, char *obj, int len1, int len2)
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj[i] = ' ';
	if ((s = getenv(name)) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj[i] = s[i];
		return 1;
	}
}
#endif
#if	defined(HP800)
int igenv_(name, len1, n, obj, len2)
char *name; int len1; int *n; char *obj; int len2;
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj[i] = ' ';
	if ((s = getenv(name)) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj[i] = s[i];
		return 1;
	}
}
#endif
#if	defined(HP300)
int igenv_(name, n, obj, len1, len2)
char *name; int *n; char *obj; int len1, len2;
{
	char *s;
	int i;
	for (i = 0; i < *n; i++)
		obj[i] = ' ';
	if ((s = getenv(name)) == (char *)0)
		return 0;
	else {
		for (i = 0; s[i] != '\0' && i < *n; i++)
			obj[i] = s[i];
		return 1;
	}
}
#endif
