#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD and SYSV */
/*----------------------------------------------------------------------*/
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "opifpix.h"
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void ifpix_uchar(void *buffer,
const int size,
const int rop,
const double cons,
const int aop,
const double value)
#else	/* old style */
void ifpix_uchar(buffer, size, rop, cons, aop, value)
void *buffer;
const int size;
const int rop;
const double cons;
const int aop;
const double value;
#endif
{
	UCHAR *p = (UCHAR *)buffer;
	const UCHAR c = (UCHAR)cons;
	const int v = (int)value;
	const int h = (int)UCHAR_Max;
	int i, d;
	switch(rop) {
	case '<':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] < c)? (UCHAR) ((d > h)? h: (d < 0)? 0: d): p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] < c)? (UCHAR) ((d < 0)? 0: (d > h)? h: d): p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] < c)? (UCHAR) ((d > h)? h: (d < 0)? 0: d): p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = (int)p[i]/v;
				p[i] = (p[i] < c)? (UCHAR) ((d < 0)? 0: d): p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] < c)? (UCHAR) v: p[i];
			break;
		default:
			break;
		}
		break;
	case '>':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] > c)? (UCHAR) ((d > h)? h: (d < 0)? 0: d): p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] > c)? (UCHAR) ((d < 0)? 0: (d > h)? h: d): p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] > c)? (UCHAR) ((d > h)? h: (d < 0)? 0: d): p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = (int)p[i]/v;
				p[i] = (p[i] > c)? (UCHAR) ((d < 0)? 0: d): p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] > c)? (UCHAR) v: p[i];
			break;
		default:
			break;
		}
		break;
	case '=':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] == c)? (UCHAR) ((d > h)? h: (d < 0)? 0: d): p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] == c)? (UCHAR) ((d < 0)? 0: (d > h)? h: d): p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] == c)? (UCHAR) ((d > h)? h: (d < 0)? 0: d): p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = (int)p[i]/v;
				p[i] = (p[i] == c)? (UCHAR) ((d < 0)? 0: d): p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] == c)? (UCHAR) v: p[i];
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
}
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void ifpix_short(void *buffer,
const int size,
const int rop,
const double cons,
const int aop,
const double value,
const double blank)
#else	/* old style */
void ifpix_short(buffer, size, rop, cons, aop, value, blank)
void *buffer;
const int size;
const int rop;
const double cons;
const int aop;
const double value;
const double blank;
#endif
{
	short *p = (short *) buffer;
	const short b = (short) blank;
	const short c = (short) cons;
	const LONG v = (LONG) value;
	const LONG h = (LONG) SHORT_Max;
	const LONG l = (LONG) SHORT_Min;
	LONG d;
	int i;
	switch(rop) {
	case '<':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] != b && p[i] < c)?
						(d > h || d < l)? b: (short)d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] != b && p[i] < c)?
						(d < l || d > h)? b: (short)d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] != b && p[i] < c)?
						(d > h || d < l)? b: (short)d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] != b && p[i] < c)? (short)d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] != b && p[i] < c)? (short)v: p[i];
			break;
		default:
			break;
		}
		break;
	case '>':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] != b && p[i] > c)?
						(d > h || d < l)? b: (short)d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] != b && p[i] > c)?
						(d < l || d > h)? b: (short)d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] != b && p[i] > c)?
						(d > h || d < l)? b: (short)d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] != b && p[i] > c)? (short)d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] != b && p[i] > c)? (short)v: p[i];
			break;
		default:
			break;
		}
		break;
	case '=':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] != b && p[i] == c)?
						(d > h || d < l)? b: (short)d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] != b && p[i] == c)?
						(d < l || d > h)? b: (short)d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] != b && p[i] == c)?
						(d > h || d < l)? b: (short)d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] != b && p[i] == c)? (short)d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] == c)? (short)v: p[i];
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
}
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void ifpix_long(void *buffer,
const int size,
const int rop,
const double cons,
const int aop,
const double value,
const double blank)
#else	/* old style */
void ifpix_long(buffer, size, rop, cons, aop, value, blank)
void *buffer;
const int size;
const int rop;
const double cons;
const int aop;
const double value;
const double blank;
#endif
{
	LONG *p = (LONG *) buffer;
	const LONG b = (LONG) blank;
	const LONG c = (LONG) cons;
	const float v = (float) value;
	const float h = (float) LONG_Max;
	const float l = (float) LONG_Min;
	float d;
	int i;
	switch(rop) {
	case '<':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] != b && p[i] < c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] != b && p[i] < c)?
						(d < l || d > h)? b: (LONG)d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] != b && p[i] < c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] != b && p[i] < c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] != b && p[i] < c)? (LONG)v: p[i];
			break;
		default:
			break;
		}
		break;
	case '>':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] != b && p[i] > c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] != b && p[i] > c)?
						(d < l || d > h)? b: (LONG)d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] != b && p[i] > c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] != b && p[i] > c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] != b && p[i] > c)? (LONG)v: p[i];
			break;
		default:
			break;
		}
		break;
	case '=':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] != b && p[i] == c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] != b && p[i] == c)?
						(d < l || d > h)? b: (LONG)d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] != b && p[i] == c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] != b && p[i] == c)?
						(d > h || d < l)? b: (LONG)d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] == c)? (LONG)v: p[i];
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
}
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void ifpix_float(void *buffer,
const int size,
const int rop,
const double cons,
const int aop,
const double value,
const double blank)
#else	/* old style */
void ifpix_float(buffer, size, rop, cons, aop, value, blank)
void *buffer;
const int size;
const int rop;
const double cons;
const int aop;
const double value;
const double blank;
#endif
{
	float *p = (float *) buffer;
	const float b = (float) blank;
	const float c = (float) cons;
	const float v = (float) value;
	const float h = (float) (0.9*blank);
	float d;
	int i;
	switch(rop) {
	case '<':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] <= h && p[i] < c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] <= h && p[i] < c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] <= h && p[i] < c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] <= h && p[i] < c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] <= h && p[i] < c)? v: p[i];
			break;
		default:
			break;
		}
		break;
	case '>':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] <= h && p[i] > c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] <= h && p[i] > c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] <= h && p[i] > c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] <= h && p[i] > c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] <= h && p[i] > c)? v: p[i];
			break;
		default:
			break;
		}
		break;
	case '=':
		switch (aop) {
		case '+':
			for (i = 0; i < size; ++i) {
				d = p[i] + v;
				p[i] = (p[i] <= h && p[i] == c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '-':
			for (i = 0; i < size; ++i) {
				d = p[i] - v;
				p[i] = (p[i] <= h && p[i] == c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '*':
			for (i = 0; i < size; ++i) {
				d = p[i] * v;
				p[i] = (p[i] <= h && p[i] == c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '/':
			for (i = 0; i < size; ++i) {
				d = p[i]/v;
				p[i] = (p[i] <= h && p[i] == c)?
						(d > h || d < -h)? b: d: p[i];
			}
			break;
		case '=':
			for (i = 0; i < size; ++i)
				p[i] = (p[i] == c)? v: p[i];
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
}
/*----------------------------------------------------------------------*/
