#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>	/* declarations for stream I/O functions */
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "exitret.h"	/* define EXIT values, if not defined */
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "daa.h"	/* function declarations for daa.c */
#include "args.h"	/* function declaration for args.c */
/*--------------------------------------------------------------------*/
#include "vmalloc.h"	/* function declarations for vmalloc.c */
#include "chkheap.h"	/* redefine malloc functions */
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
main(int Argc, char **Argv)
#else	/* old style */
main(Argc, Argv)
int Argc;
char **Argv;
#endif
{
	int argc;
	char **argv;
	int i, x, y, z;
	char *ptr;
	unsigned err, ndim;
	int st[10], dim[10];
	long init = 0L;
	unsigned size = sizeof(long);
#if	defined(ARGS)
	/* substitute some arguments (: or !) from previous command line */
	argv = args(Argc, Argv, &argc);
#else	/* no substitution */
	argc = Argc;
	argv = Argv;
#endif

	if (argc < 2) {
		printf("Usage: daatest ndim dim1 dim2 dim3 ..\n");
		fflush(stdout);
		exit(EXIT_FAILURE);
	}
	sscanf(argv[1], "%d", &ndim);
	if (ndim == 0) {
		fprintf(stderr, "daatest: ndim = %d\n", ndim);
		exit(EXIT_FAILURE);
	}
	if (argc < 2+ndim) {
		printf("Usage: daatest ndim dim1 dim2 dim3 ..\n");
		exit(EXIT_FAILURE);
	}
	for (i = 0; i < ndim; i++) {
		st[i] = -i;
		sscanf(argv[2+i], "%d", &dim[i]);
		if (dim[i] == 0) {
			fprintf(stderr, "daatest: dim[%d] = %d\n", i, dim[i]);
			exit(EXIT_FAILURE);
		}
	}
	switch (ndim) {
		case 1:
			{
				long *a = (long *)daa(size,ndim,dim,st,&err,&ptr,&init);
				for (x = st[0]; x < st[0]+dim[0]; x++)
					printf("%08x ", (long) &a[x]);
				printf("\n");
			}
			break;
		case 2:
			{
				long **a = (long **)daa(size,ndim,dim,st,&err,&ptr,&init);
				for (x = st[0]; x < st[0]+dim[0]; x++) {
					for (y = st[1]; y < st[1]+dim[1]; y++)
						printf("%08x ", (long) &a[x][y]);
					printf("\n");
				}
			}
			break;
		case 3:
			{
				long ***a = (long ***)daa(size,ndim,dim,st,&err,&ptr,&init);
				for (x = st[0]; x < st[0]+dim[0]; x++) {
					for (y = st[1]; y < st[1]+dim[1]; y++) {
						for (z = st[2]; z < st[2]+dim[2]; z++)
							printf("%08x ", (long) &a[x][y][z]);
						printf("\n");
					}
					printf("\n");
				}
			}
			break;
		case 4:
			{
				long ****a = (long ****)daa(size,ndim,dim,st,&err,&ptr,&init);
				for (x = st[0]; x < st[0]+dim[0]; x++) {
					for (y = st[1]; y < st[1]+dim[1]; y++) {
						for (z = st[2]; z < st[2]+dim[2]; z++) {
							for (i = st[3]; i < st[3]+dim[3]; i++)
								printf("%08x ", (long) &a[x][y][z][i]);
							printf("\n");
						}
						printf("\n");
					}
					printf("\n");
				}
			}
			break;
		default:
			break;
	}
	fflush(stdout);
	exit(EXIT_SUCCESS);
}
