#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>	/* declarations for stream I/O functions */
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "exitret.h"	/* define EXIT values, if not defined */
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "nr.h"	/* function declarations for nr.c */
#include "args.h"	/* function declaration for args.c */
/*--------------------------------------------------------------------*/
#include "vmalloc.h"	/* function declarations for vmalloc.c */
#include "chkheap.h"	/* redefine malloc functions */
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
main(int Argc, char **Argv)
#else	/* old style */
main(Argc, Argv)
int Argc;
char **Argv;
#endif
{
	int argc;
	char **argv;
	int x, y, Xmin, Xmax, Ymin, Ymax;
	float **m, z;
#if	defined(ARGS)
	/* substitute some arguments (: or !) from previous command line */
	argv = args(Argc, Argv, &argc);
#else	/* no substitution */
	argc = Argc;
	argv = Argv;
#endif

	if (argc < 5) {
		printf("Usage: fmattest Xmin Xmax Ymin Ymax\n");
		fflush(stdout);
		exit(EXIT_FAILURE);
	}
	sscanf(argv[1], "%d", &Xmin);
	sscanf(argv[2], "%d", &Xmax);
	sscanf(argv[3], "%d", &Ymin);
	sscanf(argv[4], "%d", &Ymax);
	if ((m = fmatrix(Ymin, Ymax, Xmin, Xmax)) == NULL) {
		fprintf(stderr, "fmattest: Can't allocate matrix\n");
		exit(EXIT_FAILURE);
	}

	z = 0;
	for (y = Ymin; y <= Ymax; ++y)
		for (x = Xmin; x <= Xmax; ++x)
			m[y][x] = z++;

	for (y = Ymin; y <= Ymax; ++y) {
		for (x = Xmin; x <= Xmax; ++x)
			printf("%4.0f", m[y][x]);
		printf("\n");
	}
	free(&m[Ymin]);

	fflush(stdout);
	exit(EXIT_SUCCESS);
}
