#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>	/* declarations for stream I/O functions */
#include <string.h>	/* declarations for string functions */
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "exitret.h"	/* define EXIT values, if not defined */
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "imhdr.h"	/* function declarations for imhdr.c */
#include "imkw.h"	/* function declarations for imkw.c */
#include "args.h"	/* function declaration for args.c */
/*--------------------------------------------------------------------*/
char *punct = "!\"#%&\'()*+,-./:;<=>?[\\]^{|}~";
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
main(int Argc, char **Argv)
#else	/* old style */
main(Argc, Argv)
int Argc;
char **Argv;
#endif
{
	int argc;
	char **argv;
	char *n;
	int i;

#if	defined(ARGS)
	/* substitute some arguments (: or !) from previous command line */
	argv = args(Argc, Argv, &argc);
#else	/* no substitution */
	argc = Argc;
	argv = Argv;
#endif

	if(argc < 2) {
		printf("Usage: getkey image\n");
		printf("A test program which reads FITS keywords\n");
		fflush(stdout);
		exit(EXIT_FAILURE);
	}
	n = truncname(argv[1]);
	if (strpbrk(n, punct) != (char *)0) {
		fprintf(stderr, "getkey: Illegal image name: %s\n", n);
		exit(EXIT_FAILURE);
	}
	/* read image names from header directory */
	if ((i = prolog(0)) < 1) {	/* select first token in HDRPATH */
		fprintf(stderr, "getkey: prolog: Error = %d\n", i);
		exit(EXIT_FAILURE);
	}
	printf("SIMPLE = %d\n", simple(n));
	printf("BITPIX = %d\n", bitpix(n));
	printf("NAXIS = %d\n", naxis(n));
	printf("NAXIS1 = %d\n", naxis1(n));
	printf("NAXIS2 = %d\n", naxis2(n));
	printf("BSCALE = %f\n", bscale(n));
	printf("BZERO = %f\n", bbzero(n));
	if(bunit(n) != NULL)
		printf("BUNIT = %s\n", bunit(n));
	printf("BLANK = %f\n", blank(n));
	if(object(n) != NULL)
		printf("OBJECT = %s\n", object(n));
	if(date(n) != NULL)
		printf("DATE = %s\n", date(n));
	if(dateobs(n) != NULL)
		printf("DATE-OBS = %s\n", dateobs(n));
	if(origin(n) != NULL)
		printf("ORIGIN = %s\n", origin(n));
	if(instrume(n) != NULL)
		printf("INSTRUME = %s\n", instrume(n));
	if(telescop(n) != NULL)
		printf("TELESCOP = %s\n", telescop(n));
	if(observer(n) != NULL)
		printf("OBSERVER = %s\n", observer(n));
	if(history(n) != NULL)
		printf("HISTORY = %s\n", history(n));
	printf("CRVAL1 = %f\n", crval1(n));
	printf("CRVAL2 = %f\n", crval2(n));
	printf("CRPIX1 = %f\n", crpix1(n));
	printf("CRPIX2 = %f\n", crpix2(n));
	printf("CDELT1 = %f\n", cdelt1(n));
	printf("CDELT2 = %f\n", cdelt2(n));
	if(ctype1(n) != NULL)
		printf("CTYPE1 = %s\n", ctype1(n));
	if(ctype2(n) != NULL)
		printf("CTYPE2 = %s\n", ctype2(n));
	printf("CROTA1 = %f\n", crota1(n));
	printf("CROTA2 = %f\n", crota2(n));
	printf("DATAMAX = %f\n", datamax(n));
	printf("DATAMIN = %f\n", datamin(n));
	printf("EPOCH = %f\n", epoch(n));
	printf("JD-START = %f\n", jdstart(n));
	printf("JD-STOP = %f\n", jdstop(n));
	printf("EXPTIME = %f\n", exptime(n));
	printf("DARKTIME = %f\n", darktime(n));
	printf("SATURATE = %f\n", saturate(n));
	printf("ATODGAIN = %f\n", atodgain(n));
	if(iname(n) != NULL)
		printf("IMAGE = %s\n", iname(n));
	if (epilog() < 1) {	/* update disk headers */
		fprintf(stderr, "getkey: epilog: Disk header(s) not updated\n");
		exit(EXIT_FAILURE);
	}
	fflush(stdout);
	exit(EXIT_SUCCESS);
}
