#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>	/* declarations for stream I/O functions */
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "exitret.h"	/* define EXIT values, if not defined */
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "imhdr.h"	/* function declarations for imhdr.c */
#include "args.h"	/* function declaration for args.c */
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
main(int Argc, char **Argv)
#else	/* old style */
main(Argc, Argv)
int Argc;
char **Argv;
#endif
{
	int argc;
	char **argv;
	char **itab;
	int i, n;

#if	defined(ARGS)
	/* substitute some arguments (: or !) from previous command line */
	argv = args(Argc, Argv, &argc);
#else	/* no substitution */
	argc = Argc;
	argv = Argv;
#endif

	if (argc < 2) {
		printf("Usage: rddir directory\n");
		fflush(stdout);
		exit(EXIT_FAILURE);
	}
	if ((i = prolog(0)) < 1) {	/* select first token in HDRPATH */
		fprintf(stderr, "rddir: prolog error: %d\n", i);
		exit(EXIT_FAILURE);
	}
	if ((i = rddir(argv[1])) < 1) {
		fprintf(stderr, "rddir: rddir error: %d\n", i);
		exit(EXIT_FAILURE);
	}
	if ((itab = getitab(&n)) == (char **)0) {
		printf("no images\n");
		exit(EXIT_FAILURE);
	}
	for (i = 0; i < n; i++) {
		if (i%5 == 0)
			printf("\n");
		else
			printf("\t");
		printf("%-8s", itab[i]);
	}
	if (n != 0)
		printf("\n");
	printf("\n%d images\n", n);
	if (epilog() < 1) {	/* save headers on disk */
		fprintf(stderr, "rddir: epilog error: Header(s) not saved\n");
		exit(EXIT_FAILURE);
	}
	fflush(stdout);
	exit(EXIT_SUCCESS);
}
