#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>	/* declarations for stream I/O functions */
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "exitret.h"	/* define EXIT values, if not defined */
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "getopt.h"	/* declarations for getopt.c */
#include "args.h"	/* function declaration for args.c */
/*--------------------------------------------------------------------*/
#include "vmalloc.h"	/* function declarations for vmalloc.c */
#include "chkheap.h"	/* redefine malloc functions */
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
main(int Argc, char **Argv)
#else	/* old style */
main(Argc, Argv)
int Argc;
char **Argv;
#endif
{
	int argc;
	char **argv;
	int option, opt_err = 0;
	int n_arg = 0;
	char **arg;
	int append = 0;
	char str[81];
	FILE *fp = NULL;

#if	defined(ARGS)
	/* substitute some arguments (: or !) from previous command line */
	argv = args(Argc, Argv, &argc);
#else	/* no substitution */
	argc = Argc;
	argv = Argv;
#endif

	if ((arg = (char **)calloc(argc, sizeof (char *))) == (char **)0) {
		fprintf(stderr, "tee: calloc: Can't allocate argument table\n");
		exit(EXIT_FAILURE);
	}

	while (((option = getopt(argc, argv, "a")) != NONOPT)
			|| (optarg != NULL)) {
		switch(option) {
			case 'a':	append++; break;
			case '?':	opt_err++; break;
			case NONOPT:	arg[n_arg++] = optarg; break;
			default:		break;
		}
	}

	if (opt_err || n_arg < 1) {
		fprintf(stderr, "Usage: tee -a file\n");
		fflush(stdout);
		exit(EXIT_FAILURE);
	}

	if (append == 0) {
		if ((fp = fopen(arg[0], "w")) == NULL) {
			fprintf(stderr, "tee: Can't open %s for writing\n", arg[0]);
			exit(EXIT_FAILURE);
		}
	} else {
		if ((fp = fopen(arg[0], "a")) == NULL) {
			fprintf(stderr, "tee: Can't open %s for appending\n", arg[0]);
			exit(EXIT_FAILURE);
		}
	}

	str[0] = '\n';
	str[1] = '\0';
	fgets(str, 80, stdin);
	while (!feof(stdin)) {
		fputs(str, fp);
		fflush(fp);
		fputs(str, stdout);
		fflush(stdout);
		str[0] = '\n';
		str[1] = '\0';
		fgets(str, 80, stdin);
	}

	fclose(fp);
	free(arg);
	fflush(stdout);
	exit(EXIT_SUCCESS);
}
